/**
* Kommentierter C++ Code zur Aufgabe 1 der letzten Stunde (07.11.2015)
* Code stellt eine mögliche Lösung dar. Es gibt natürlich auch andere Wege ;) 
* Kurs: Grundlagen C/C++
* Author: Lorenz Schauer
*/
#include <iostream>

#define length(x) sizeof(x)/sizeof(x[0])

// Main-Methode
int main(){

	// booleans können nun so verwendet werden. 
	bool terminieren = false;

	//Array für die Eingaben erzeugen:
	int eingaben[5];
	
	//Pointer erzeugen und auf die Anfangsadresse des Arrays zeigen lassen: 
	int *pos = eingaben;

	//Lokale Variable für Nutzereingabe:
	int zahl;
	
	//While-Schleife für Nutzereingaben
	while(!terminieren){

		std::cout << "Bitte geben Sie eine Zahl ein: ";
		std::cin >> zahl;

		//Falls eingegebene Zahl gleich 0 dann aufhören!
		if(zahl==0){

			terminieren = true;
		}

		// Andernfalls: 
		else{
			//Eingegebene Zahl im Array speichern
			*pos = zahl;
			
			//Pointer auf nächstes Array-Element zeigen lassen
			pos++;
			
			//Falls der Pointer nun auf das Ende des Arrays zeigt: Nutzer informieren und terminieren der While-Schleife
			if(pos==&eingaben[length(eingaben)]){
				std::cout << "Es koennen keine weiteren Eingaben mehr getaetigt werden!\nAbbruch der Eingabe\n";
				terminieren = true;
			}
		}
	}// Nutzereingaben beendet. 
	
	//Falls Nutzer sofort 0 eingegeben hat:
	
	if(pos==eingaben){
		std::cout << "Keine Nutzereingabe getaetigt!";	
	}
	
	// Falls (neben 0) mind. eine Zahl eingegeben wurde:
	else{
		
		
		/**
		****************************************
		* Ein paar lokale Variablen anlegen für die Berechnungen auf dem Array:
		****************************************
		*/	
		// Pointer für aktuelle Array Position anlegen
		int* actual_pos;	
		
		// Variabel für kleinste Zahl = erstes Array-Element
		int kleinsteZahl = eingaben[0]; 
		
		// Variable für größte Zahl = erstes Array-Element
		int groesste_Zahl = eingaben[0];
		
		// Summe =0
		double sum=0.0;
		
		// Index = 0
		int index = 0;	
		
		/*
		*********************************************
		*/
		
		// Array durchlaufen:
		for(actual_pos=eingaben; actual_pos<pos; actual_pos++){
			
			//Zahlen normal ausgeben
			std::cout << " "<<*actual_pos;
			
			//Summe akkumiulieren
			sum=sum+ *actual_pos;
			
			//Index erhöhen
			index++;
			
			// Falls aktueller Array-Wert kleiner als Zahl in lokaler Variabeln kleinsteZahl, dann kleinsteZahl auf aktuellen Array-Wert setzen
			if(*actual_pos<kleinsteZahl)
				kleinsteZahl=*actual_pos;

			// Falls aktueller Array-Wert größer als Zahl in lokaler Variabeln groesste_Zahl, dann groesste_Zahl auf aktuellen Array-Wert setzen
			if(*actual_pos>groesste_Zahl)
				groesste_Zahl=*actual_pos;
			
		}
		std::cout << "\n";
		
		// Ausgaben der Berechnungen auf der Konsole
		std::cout << "Der Durchschnitt Ihrer Eingaben lautet: "<< sum/index <<"\n";
		std::cout << "Ihre kleinste Eingabe war: "<< kleinsteZahl<<"\n";
		std::cout << "Ihre groesste Eingabe war: "<< groesste_Zahl<<"\n";


	}// Ende des Else-Teils
	
	
	// Programm terminiert
	return 0;
}